import time
import json
import requests
import os
import xbmc
import xbmcgui
import xbmcaddon
from contextlib import closing
from xbmcvfs import File
import xbmcvfs


class ABC:
    def __init__(self, ADDON):
        self.ADDON = ADDON

    def first_run(self):
        videos_db_path = 'special://userdata/Database/MyVideos119.db'
        if not xbmcvfs.exists(videos_db_path):
            xbmcvfs.mkdir('special://userdata/Database/')

        # change settings
        try:
            xbmc.executebuiltin('Skin.SetBool(circle_rating,true)')
            xbmc.executebuiltin('Skin.SetBool(show_weatherinfo,true)')
        except:
            pass

        if not xbmcvfs.exists('special://userdata/library/music/'):
            xbmcvfs.mkdir('special://userdata/library/music/')

        if not xbmcvfs.exists('special://userdata/library/video/'):
            xbmcvfs.mkdir('special://userdata/library/video/')

        if not xbmcvfs.exists('special://userdata/library/video/movies/'):
            xbmcvfs.mkdir('special://userdata/library/video/movies/')

        if not xbmcvfs.exists('special://userdata/library/video/musicvideos/'):
            xbmcvfs.mkdir('special://userdata/library/video/musicvideos/')

        if not xbmcvfs.exists('special://userdata/library/video/tvshows/'):
            xbmcvfs.mkdir('special://userdata/library/video/tvshows/')

        data = """
            <advancedsettings version="1.0">
            <myvideos>
                <extractchapterthumbs default="true">true</extractchapterthumbs>
                <extractflags default="true">true</extractflags>
                <extractthumb default="true">true</extractthumb>
                <flatten default="true">false</flatten>
                <replacelabels default="true">true</replacelabels>
                <selectaction>3</selectaction>
                <stackvideos default="true">false</stackvideos>
                <watchmodemovies>0</watchmodemovies>
                <watchmodetvshows>0</watchmodetvshows>
                <watchmodemusicvideos>0</watchmodemusicvideos>
                <playlist>
                    <repeat>false</repeat>
                    <shuffle>false</shuffle>
                </playlist>
                <needsupdate>0</needsupdate>
            </myvideos>
            <setting id="weather.addon">weather.gismeteo</setting>
            <setting id="weather.currentlocation" default="true">1</setting>
            <setting id="locale.temperatureunit">c</setting>
            </advancedsettings>
            """

        try:
            with closing(File("special://userdata/advancedsettings.xml", 'w')) as fo:
                fo.write(data)
        except:
            pass

        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/albums.xml', 'special://userdata/library/music/albums.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/artists.xml', 'special://userdata/library/music/artists.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/compilations.xml', 'special://userdata/library/music/compilations.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/playlists.xml', 'special://userdata/library/music/playlists.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/singles.xml', 'special://userdata/library/music/singles.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/music/years.xml', 'special://userdata/library/music/years.xml')

        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/actors.xml', 'special://userdata/library/video/movies/actors.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/country.xml', 'special://userdata/library/video/movies/country.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/directors.xml', 'special://userdata/library/video/movies/directors.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/genres.xml', 'special://userdata/library/video/movies/genres.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/index.xml', 'special://userdata/library/video/movies/index.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/recentlyaddedmovies.xml', 'special://userdata/library/video/movies/recentlyaddedmovies.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/sets.xml', 'special://userdata/library/video/movies/sets.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/studios.xml', 'special://userdata/library/video/movies/studios.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/tags.xml', 'special://userdata/library/video/movies/tags.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/titles.xml', 'special://userdata/library/video/movies/titles.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/movies/years.xml', 'special://userdata/library/video/movies/years.xml')

        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/albums.xml', 'special://userdata/library/video/musicvideos/albums.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/artists.xml', 'special://userdata/library/musicvideos/artists.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/directors.xml', 'special://userdata/library/video/musicvideos/directors.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/genres.xml', 'special://userdata/library/musicvideos/genres.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/index.xml', 'special://userdata/library/musicvideos/index.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/recentlyaddedmusicvideos.xml', 'special://userdata/library/musicvideos/recentlyaddedmusicvideos.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/studios.xml', 'special://userdata/library/video/musicvideos/studios.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/tags.xml', 'special://userdata/library/video/musicvideos/tags.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/titles.xml', 'special://userdata/library/video/musicvideos/titles.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/musicvideos/years.xml', 'special://userdata/library/video/musicvideos/years.xml')

        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/actors.xml', 'special://userdata/library/video/tvshows/actors.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/genres.xml', 'special://userdata/library/video/tvshows/genres.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/index.xml', 'special://userdata/library/video/tvshows/index.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/inprogressshows.xml', 'special://userdata/library/video/tvshows/inprogressshows.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/recentlyaddedepisodes.xml', 'special://userdata/library/video/tvshows/recentlyaddedepisodes.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/studios.xml', 'special://userdata/library/video/tvshows/studios.xml')
        # xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/tags.xml', 'special://userdata/library/video/tvshows/tags.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/titles.xml', 'special://userdata/library/video/tvshows/titles.xml')
        xbmcvfs.copy('special://xbmc/addons/abc.service/library/tvshows/years.xml', 'special://userdata/library/video/tvshows/years.xml')


    def update_language(self):
        app_language = self.ADDON.getSetting('app_language')
        try:
            if app_language == '1':
                xbmc.executebuiltin('xbmc.SetGUILanguage(resource.language.fa_ir)')
            elif app_language == '0':
                xbmc.executebuiltin('xbmc.SetGUILanguage(resource.language.en_us)')
        except:
            pass
