#!/usr/bin/python

import os
import xbmc
import xbmcaddon
import json
import requests
import base64

__addon__ = xbmcaddon.Addon()
__author__ = __addon__.getAddonInfo('author')
__scriptid__ = __addon__.getAddonInfo('id')
__scriptname__ = __addon__.getAddonInfo('name')
__version__ = __addon__.getAddonInfo('version')
__language__ = __addon__.getLocalizedString
# __cwd__ = xbmc.translatePath(__addon__.getAddonInfo('path'))
# __profile__ = xbmc.translatePath(__addon__.getAddonInfo('profile'))
# __resource__ = xbmc.translatePath(os.path.join(__cwd__, 'resources'))

__settings__ = xbmcaddon.Addon("abc.subtitle")

currentPlaying = ""

monitor = xbmc.Monitor()


def Debug(msg, force=False):
    xbmc.log("#####[ABC Subtitle]##### " + msg, xbmc.LOGDEBUG)


Debug("Loading '%s' version '%s'" % (__scriptname__, __version__))


class AutoSubsPlayer(xbmc.Player):
    def __init__(self, *args, **kwargs):
        self.api = 'http://amazon-player.amazonapi.online'
        # self.api = 'http://127.0.0.1:8010'
        xbmc.Player.__init__(self)
        Debug("Initialized")
        self.run = True

    def _fetch_json(self, url):
        try:
            headers = {'Content-Type': 'application/json; charset=utf-8', "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.79 Safari/537.36 / ABC_Subtitle 3.0.0"}
            result = requests.get(url, headers=headers).json()
            return result
        except Exception as e:
            return None

    def onPlayBackStopped(self):
        Debug("Stopped")
        self.run = True

    def onPlayBackEnded(self):
        Debug("Ended")
        self.run = True

    def onPlayBackStarted(self):
        # Debug(xbmc.getInfoLabel('ListItem.FileNameAndPath'))
        # movie_full_path = self.getPlayingFile()
        movie_full_path = xbmc.getInfoLabel('ListItem.FileNameAndPath')
        parameter = 'filename=%s' % (movie_full_path,)
        url = '%s/k-stream/subtitles/%s/' % (self.api, base64.urlsafe_b64encode(parameter.encode('utf-8')).decode('utf-8'))
        result = self._fetch_json(url)
        if result:
            for subtitle in result:
                self.setSubtitles(subtitle['url'])


class AutoSubsRunner:
    player = AutoSubsPlayer()
    while not monitor.abortRequested():
        monitor.waitForAbort(1)

    del player
