from future import standard_library

standard_library.install_aliases()  # noqa: E402

import time
import xbmc
import xbmcplugin
import xbmcgui
from contextlib import closing
from xbmcvfs import File
import xbmcvfs
import json
import sys
import os
import re
import xbmcaddon
import requests
import uuid
import updater
import functions

ADDON = xbmcaddon.Addon('abc.service')

addon_version = '4'


def refresh_auth():
    _token = ADDON.getSetting('abc_user_token')
    if not _token:
        _token = uuid.uuid4().hex
        ADDON.setSetting('abc_user_token', _token)
    username = ADDON.getSetting('username')
    password = ADDON.getSetting('password')
    downloads = ADDON.getSetting('downloads')

    xbmcgui.Window(10000).setProperty('abc_user_token', _token)
    xbmcgui.Window(10000).setProperty('abc_username', username)
    xbmcgui.Window(10000).setProperty('abc_password', password)
    xbmcgui.Window(10000).setProperty('abc_downloads', downloads)


def init():
    abc_functions = functions.ABC(ADDON)
    refresh_auth()

    _first_run = ADDON.getSetting('abc_firstrun' + addon_version)
    if not _first_run:
        xbmcaddon.Addon().openSettings()

        refresh_auth()
        abc_functions.first_run()
        ADDON.setSetting('abc_firstrun' + addon_version, 'True')
    else:
        pass

    _Updater = updater.Updater(ADDON)
    _Updater.start()



def router(paramstring, arg1):
    abc_functions = functions.ABC(ADDON)
    run = True
    if arg1 == 'abc-settings-save':
        _token = uuid.uuid4().hex
        ADDON.setSetting('abc_user_token', _token)
        refresh_auth()
        run = False

    if arg1 == 'abc-update-db':
        run = False

    params = paramstring.split('/')

    if len(params) >= 4 and params[3] == 'abc-settings':
        run = False
        xbmcaddon.Addon().openSettings()
        if ADDON.getSetting('app_data_language') != ADDON.getSetting('abc_current_app_data_language') or ADDON.getSetting('app_data_type') != ADDON.getSetting('abc_current_app_data_type'):
            ADDON.setSetting('abc_need_download_zip', None)
            run = True
        else:
            refresh_auth()
        xbmc.executebuiltin('Dialog.Close(busydialog)')
        xbmc.executebuiltin('ActivateWindow(10000)')

    if len(params) >= 4 and params[3] == 'abc-update-db':
        run = False
        _Updater = updater.Updater(ADDON)
        xbmc.executebuiltin('Dialog.Close(busydialog)')
        xbmc.executebuiltin('ActivateWindow(10000)')
        _Updater.update_database()

    if run:
        init()


if __name__ == '__main__':
    arg1 = ''
    if len(sys.argv) > 1:
        arg1 = sys.argv[1]
    router(sys.argv[0], arg1)
